#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "Players Count CFG",
	author	= "wS",
	version = "1.0.4"
};

#define FILE_NAME_LENGTH	24
#define FSEC				2.0		// Через сколько сек, после входа/выхода/смены команды, подгрузятся .cfg

new Handle:g_hTimer = INVALID_HANDLE;
new Handle:g_hIgnoreFlagsTrie = INVALID_HANDLE;
new Handle:g_hCfgAr, g_CfgCount;
new bool:g_LastExecDefault = false;	// Если в прошлый раз был подгружен default.cfg, то снова в следующий раз этого делать не нужно.

#define IGNORE_T	(1 << 0)
#define IGNORE_CT	(1 << 1)
#define IGNORE_SPEC	(1 << 2)
#define IGNORE_BOTS	(1 << 3)
		
public OnClientPutInServer(client)		RestartTimer();
public OnClientDisconnect_Post(client)	RestartTimer();
public player_team(Handle:event, const String:name[], bool:silent) RestartTimer();

public OnMapStart()
{
	g_CfgCount = 0;
	
	if (g_hCfgAr)
	{
		ClearArray(g_hCfgAr);
		ClearTrie(g_hIgnoreFlagsTrie);
	}
	else
	{
		g_hCfgAr = CreateArray(FILE_NAME_LENGTH);
		g_hIgnoreFlagsTrie = CreateTrie();
	}
	
	static bool:player_team_hook = false;
	if (player_team_hook)
	{
		player_team_hook = false;
		UnhookEvent("player_team", player_team, EventHookMode_PostNoCopy);
	}
	
	new Handle:hDir = OpenDirectory("cfg/players_count_cfg");
	if (!hDir)
		return;
	
	// Делаем так, чтобы в g_hCfgAr всё было по возрастанию:
	// 1-1	(сначала все x-y)
	// 1-5
	// 3-7
	// 12-15
	// 1	(затем x)
	// 3
	// 5
	
	new Handle:hTempCfgAr = CreateArray(FILE_NAME_LENGTH), TempCfgCount = 0;
	decl String:sFileName[FILE_NAME_LENGTH], String:buffer[2][FILE_NAME_LENGTH/2], FileType:type, i, Handle:hFile, String:sInfo[256];
	
	while (ReadDirEntry(hDir, sFileName, sizeof(sFileName), type))
	{
		if (type == FileType_File && (i = FindCharInString(sFileName, '.', true)) > 0 && !strcmp(sFileName[i+1], "cfg", false))
		{
			sFileName[i] = 0;
			if (FindStringInArray(hTempCfgAr, sFileName) > -1)
				continue;
			
			if (ExplodeString(sFileName, "-", buffer, sizeof(buffer), sizeof(buffer[])) == 2)
			{
				if (StringToInt(buffer[0]) == StringToInt(buffer[1]) || !IsNumber(buffer[0]) || !IsNumber(buffer[1]))
					continue;
			}
			else if (!IsNumber(sFileName))
				continue;
			
			FormatEx(sInfo, sizeof(sInfo), "cfg/players_count_cfg/%s.cfg", sFileName);
			if ((hFile = OpenFile(sInfo, "rt")))
			{
				if (ReadFileLine(hFile, sInfo, sizeof(sInfo)) && sInfo[0])
				{
					i = 0;
					if (StrContains(sInfo, "IGNORE_T"	, true) > -1) i |= IGNORE_T;
					if (StrContains(sInfo, "IGNORE_CT"	, true) > -1) i |= IGNORE_CT;
					if (StrContains(sInfo, "IGNORE_SPEC", true) > -1) i |= IGNORE_SPEC;
					if (StrContains(sInfo, "IGNORE_BOTS", true) > -1) i |= IGNORE_BOTS;
					if (i)
					{
						SetTrieValue(g_hIgnoreFlagsTrie, sFileName, i, true);
						if (!player_team_hook && ((i & IGNORE_T) || (i & IGNORE_CT) || (i & IGNORE_SPEC)))
						{
							player_team_hook = true;
							HookEvent("player_team", player_team, EventHookMode_PostNoCopy);
						}
					}
				}
				CloseHandle(hFile);
				
				PushArrayString(hTempCfgAr, sFileName);
				TempCfgCount++;
			}
		}
	}
	
	CloseHandle(hDir);
	
	if (TempCfgCount < 1)
	{
		CloseHandle(hTempCfgAr);
		return;
	}
	
	decl String:s[FILE_NAME_LENGTH/2], NumCount;
	new Handle:h_NumAr = CreateArray(1);
	
	for (new players = 0; players <= MaxClients; players++) // сначала подгружаем все "x-y.cfg"
	{
		FormatEx(s, sizeof(s), "%d-", players);
		
		ClearArray(h_NumAr);
		NumCount = 0;
		
		for (i = 0; i < TempCfgCount; i++)
		{
			GetArrayString(hTempCfgAr, i, sFileName, sizeof(sFileName));
			if (StrContains(sFileName, s, true) == 0)
			{
				PushArrayCell(h_NumAr, StringToInt(sFileName[FindCharInString(sFileName, '-', true) + 1]));
				NumCount++;
			}
		}
		
		if (NumCount)
		{
			SortADTArray(h_NumAr, Sort_Ascending, Sort_Integer);
			for (i = 0; i < NumCount; i++)
			{
				FormatEx(sFileName, sizeof(sFileName), "%s%d", s, GetArrayCell(h_NumAr, i));
				PushArrayString(g_hCfgAr, sFileName);
				g_CfgCount++;
			}
		}
	}
	
	// затем подгружаем все "x.cfg"
	
	ClearArray(h_NumAr);
	NumCount = 0;
	
	for (i = 0; i < TempCfgCount; i++) 
	{
		GetArrayString(hTempCfgAr, i, sFileName, sizeof(sFileName));
		if (IsNumber(sFileName))
		{
			PushArrayCell(h_NumAr, StringToInt(sFileName));
			NumCount++;
		}
	}
	
	if (NumCount)
	{
		SortADTArray(h_NumAr, Sort_Ascending, Sort_Integer);
		for (i = 0; i < NumCount; i++)
		{
			IntToString(GetArrayCell(h_NumAr, i), sFileName, sizeof(sFileName));
			PushArrayString(g_hCfgAr, sFileName);
			g_CfgCount++;
		}
	}
	
	CloseHandle(h_NumAr);
	CloseHandle(hTempCfgAr);
	
	/*for (i = 0; i < g_CfgCount; i++)
	{
		GetArrayString(g_hCfgAr, i, sFileName, sizeof(sFileName));
		PrintToServer(sFileName);
	}*/
	
	RestartTimer();
}

public OnMapEnd()
{
	if (g_hTimer)
	{
		KillTimer(g_hTimer);
		g_hTimer = INVALID_HANDLE;
	}
	g_LastExecDefault = false;
}

RestartTimer()
{
	if (g_CfgCount)
	{
		if (g_hTimer) KillTimer(g_hTimer);
		g_hTimer = CreateTimer(FSEC, exec_cfg);
	}
}

public Action:exec_cfg(Handle:timer)
{
	g_hTimer = INVALID_HANDLE;
	
	new players = 0;
	new ts = 0;
	new cts = 0;
	new specs = 0;
	new ts_bots = 0;
	new cts_bots = 0;
	new specs_bots = 0;
	new bots = 0;
	
	decl i, f;
	
	for (i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsClientSourceTV(i) && !IsClientReplay(i))
		{
			players++;
			
			if (IsFakeClient(i))
			{
				bots++;
				f = 1;
			}
			else
				f = 0;
			
			switch (GetClientTeam(i))
			{
				case 2:
				{
					ts++;
					if (f) ts_bots++;
				}
				case 3:
				{
					cts++;
					if (f) cts_bots++;
				}
				default:
				{
					specs++;
					if (f) specs_bots++;
				}
			}
		}
	}
	
	decl String:sFileName[FILE_NAME_LENGTH], String:buffer[2][FILE_NAME_LENGTH/2], players_;
	new bool:exec = false;
	
	for (i = 0; i < g_CfgCount; i++)
	{
		players_ = players;
		GetArrayString(g_hCfgAr, i, sFileName, sizeof(sFileName));
		
		if (GetTrieValue(g_hIgnoreFlagsTrie, sFileName, f))
		{
			if (f & IGNORE_T		) players_ -= ts;
			if (f & IGNORE_CT		) players_ -= cts;
			if (f & IGNORE_SPEC		) players_ -= specs;
			
			if (f & IGNORE_BOTS		)
			{
				players_ -= bots;
				
				if (f & IGNORE_T	) players_ += ts_bots;
				if (f & IGNORE_CT	) players_ += cts_bots;
				if (f & IGNORE_SPEC	) players_ += specs_bots;
			}
		}
		
		if (ExplodeString(sFileName, "-", buffer, sizeof(buffer), sizeof(buffer[])) == 2)
		{
			if (players_ >= StringToInt(buffer[0]) && players_ <= StringToInt(buffer[1]))
			{
				exec = true;
				g_LastExecDefault = false;
				ServerCommand("exec \"players_count_cfg/%s.cfg\"", sFileName);
				//PrintToChatAll(sFileName);
			}
		}
		else
		{
			if (players_ == StringToInt(sFileName))
			{
				exec = true;
				g_LastExecDefault = false;
				ServerCommand("exec \"players_count_cfg/%s.cfg\"", sFileName);
				//PrintToChatAll(sFileName);
			}
		}
	}
	
	if (!exec && !g_LastExecDefault)
	{
		g_LastExecDefault = true;
		if (FileExists("cfg/players_count_cfg/default.cfg"))
		{
			ServerCommand("exec \"players_count_cfg/default.cfg\"");
			//PrintToChatAll("default.cfg");
		}
	}
	
	return Plugin_Stop;
}

stock bool:IsNumber(const String:s[]) // должно быть четко "1" без пробелов и левых символов
{
	new bool:yes = false ;
	new count = strlen(s);
	for (new i = 0; i < count; i++)
	{
		if (!s[i]) break;
		if (!IsCharNumeric(s[i])) return false;
		yes = true;
	}
	return yes;
}